// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rosbridge_msgs:msg/ConnectedClients.idl
// generated code does not contain a copyright notice
#include "rosbridge_msgs/msg/detail/connected_clients__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `clients`
#include "rosbridge_msgs/msg/detail/connected_client__functions.h"

bool
rosbridge_msgs__msg__ConnectedClients__init(rosbridge_msgs__msg__ConnectedClients * msg)
{
  if (!msg) {
    return false;
  }
  // clients
  if (!rosbridge_msgs__msg__ConnectedClient__Sequence__init(&msg->clients, 0)) {
    rosbridge_msgs__msg__ConnectedClients__fini(msg);
    return false;
  }
  return true;
}

void
rosbridge_msgs__msg__ConnectedClients__fini(rosbridge_msgs__msg__ConnectedClients * msg)
{
  if (!msg) {
    return;
  }
  // clients
  rosbridge_msgs__msg__ConnectedClient__Sequence__fini(&msg->clients);
}

rosbridge_msgs__msg__ConnectedClients *
rosbridge_msgs__msg__ConnectedClients__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosbridge_msgs__msg__ConnectedClients * msg = (rosbridge_msgs__msg__ConnectedClients *)allocator.allocate(sizeof(rosbridge_msgs__msg__ConnectedClients), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosbridge_msgs__msg__ConnectedClients));
  bool success = rosbridge_msgs__msg__ConnectedClients__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rosbridge_msgs__msg__ConnectedClients__destroy(rosbridge_msgs__msg__ConnectedClients * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rosbridge_msgs__msg__ConnectedClients__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rosbridge_msgs__msg__ConnectedClients__Sequence__init(rosbridge_msgs__msg__ConnectedClients__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosbridge_msgs__msg__ConnectedClients * data = NULL;

  if (size) {
    data = (rosbridge_msgs__msg__ConnectedClients *)allocator.zero_allocate(size, sizeof(rosbridge_msgs__msg__ConnectedClients), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosbridge_msgs__msg__ConnectedClients__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosbridge_msgs__msg__ConnectedClients__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosbridge_msgs__msg__ConnectedClients__Sequence__fini(rosbridge_msgs__msg__ConnectedClients__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosbridge_msgs__msg__ConnectedClients__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosbridge_msgs__msg__ConnectedClients__Sequence *
rosbridge_msgs__msg__ConnectedClients__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosbridge_msgs__msg__ConnectedClients__Sequence * array = (rosbridge_msgs__msg__ConnectedClients__Sequence *)allocator.allocate(sizeof(rosbridge_msgs__msg__ConnectedClients__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rosbridge_msgs__msg__ConnectedClients__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rosbridge_msgs__msg__ConnectedClients__Sequence__destroy(rosbridge_msgs__msg__ConnectedClients__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rosbridge_msgs__msg__ConnectedClients__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}
